-- BagInfosWindow.lua
-- written by Habna


function frmBagInfos()
	frmBI = true;
	tbackpack = backpack;
	SelCN = PN;
	import (AppClassD.."ComboBox");
	BICB = HabnaPlugins.TitanBar.Class.ComboBox();

	-- **v Set some window stuff v**
	wBI = Turbine.UI.Lotro.Window();
	wBI:SetText( L["BIh"] );
	wBI:SetPosition( BIWLeft, BIWTop );
	wBI:SetSize( 390, 495 );
	wBI:SetWantsKeyEvents( true );
	wBI:SetVisible( true );
	--wBI:SetZOrder( 2 );
	--wBI:Activate();

	wBI.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			wBI:Close();
		elseif ( args.Action == 268435635 ) or ( args.Action == 268435579 ) then -- Hide if F12 key is press or reposition UI
			wBI:SetVisible( not wBI:IsVisible() );
		end
	end

	wBI.MouseDown = function( sender, args )
		if ( args.Button == Turbine.UI.MouseButton.Left ) then dragging = true; end
	end

	wBI.MouseMove = function( sender, args )
		if dragging then if BICB.dropped then BICB:CloseDropDown(); end end
	end

	wBI.MouseUp = function( sender, args )
		dragging = false;
		settings.BagInfos.L = string.format("%.0f", wBI:GetLeft());
		settings.BagInfos.T = string.format("%.0f", wBI:GetTop());
		BIWLeft, BIWTop = wBI:GetPosition();
		SaveSettings( false );
	end

	wBI.Closing = function( sender, args ) -- Function for the Upper right X icon
		BICB.dropDownWindow:SetVisible(false);
		wBI:SetWantsKeyEvents( false );
		RemoveCallback( tbackpack, "ItemAdded" );
		RemoveCallback( tbackpack, "ItemRemoved" );
		wBI = nil;
		frmBI = nil;
	end
	-- **^
	-- **v Create an array of character name, sort it, then use it as a reference - label & DropDown box v**
	local newt = {}
	for i in pairs(PlayerBags) do
		if string.sub( i, 1, 1 ) == "~" then PlayerBags[i] = nil; else table.insert(newt, i); end --Delete session play character
	end
	table.sort(newt);

	BICB:SetParent( wBI );
	BICB:SetSize( 159, 19 );
	BICB:SetPosition( 15, 35 );

	for k,v in pairs(newt) do
		BICB:AddItem(v, k);
		if v == PN then BICB:SetSelection(k); end
	end

	BICB.ItemChanged = function () -- The event that's executed when a menu item is clicked.
		SelCN = BICB.label:GetText();
		CountItems();
	end
	-- **^
	-- **v Set the itemlistbox border v**
	wBI.ListBoxBorder = Turbine.UI.Control();
	wBI.ListBoxBorder:SetParent( wBI );
	wBI.ListBoxBorder:SetPosition( 15, 60 );
	wBI.ListBoxBorder:SetSize( wBI:GetWidth()-30, 378 );
	wBI.ListBoxBorder:SetBackColor( Color["grey"] );
	wBI.ListBoxBorder:SetVisible( true );
	-- **^
	-- **v Set the itemlistbox v**
	wBI.ListBox = Turbine.UI.ListBox();
	wBI.ListBox:SetParent( wBI );
	wBI.ListBox:SetPosition( wBI.ListBoxBorder:GetLeft() + 2, wBI.ListBoxBorder:GetTop() + 2 );
	wBI.ListBox:SetSize( wBI.ListBoxBorder:GetWidth() - 4, wBI.ListBoxBorder:GetHeight() - 4 );
	wBI.ListBox:SetMaxItemsPerLine( 1 );
	wBI.ListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	wBI.ListBox:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
	-- **^
	-- **v Set the scrollbar v**
	wBI.ListBoxScrollBar = Turbine.UI.Lotro.ScrollBar();
	wBI.ListBoxScrollBar:SetParent( wBI );
	wBI.ListBoxScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
	wBI.ListBox:SetVerticalScrollBar( wBI.ListBoxScrollBar );
	wBI.ListBoxScrollBar:SetPosition( wBI:GetWidth()-28, wBI.ListBox:GetTop() + 2 );
	wBI.ListBoxScrollBar:SetSize( 10, wBI.ListBox:GetHeight() - 2 );
	-- **^

	-- **v Show used slot info in tooltip? v**
	wBI.UsedSlots = Turbine.UI.Lotro.CheckBox();
	wBI.UsedSlots:SetParent( wBI );
	wBI.UsedSlots:SetPosition( 30, wBI.ListBox:GetTop() + wBI.ListBox:GetHeight() + 6 );
	wBI.UsedSlots:SetText( L["BIUsed"] );
	wBI.UsedSlots:SetSize( wBI.UsedSlots:GetTextLength() * 8.5, 20 );
	wBI.UsedSlots:SetChecked( BIUsed );
	wBI.UsedSlots:SetForeColor( Color["rustedgold"] );

	wBI.UsedSlots.CheckedChanged = function( sender, args )
		_G.BIUsed = wBI.UsedSlots:IsChecked();
		settings.BagInfos.U = _G.BIUsed;
		SaveSettings( false );
		UpdateBackpackInfos();
	end
	-- **^
	-- **v Show max slot in tooltip? v**
	wBI.BIMaxSlots = Turbine.UI.Lotro.CheckBox();
	wBI.BIMaxSlots:SetParent( wBI );
	wBI.BIMaxSlots:SetPosition( 30, wBI.UsedSlots:GetTop() + wBI.UsedSlots:GetHeight() );
	wBI.BIMaxSlots:SetText( L["BIMax"] );
	wBI.BIMaxSlots:SetSize( wBI.BIMaxSlots:GetTextLength() * 8.5, 20 );
	wBI.BIMaxSlots:SetChecked( BIMax );
	wBI.BIMaxSlots:SetForeColor( Color["rustedgold"] );

	wBI.BIMaxSlots.CheckedChanged = function( sender, args )
		_G.BIMax = wBI.BIMaxSlots:IsChecked();
		settings.BagInfos.M = _G.BIMax;
		SaveSettings( false );
		UpdateBackpackInfos();
	end
	-- **^
	
	AddCallback(tbackpack, "ItemAdded", 
		function(sender, args)
		if frmBI then
			backpackCount = 0;
			if SelCN == PN then
				SavePlayerBags();
				CountItems();
			end
		end
	end);

	--**v Workaround for the ItemRemoved that fire before the backpack was updated (Turnine API issue) v**
	BIItemRemovedTimer = Turbine.UI.Control();
	BIItemRemovedTimer.Update = function( sender, args )
		BIItemRemovedTimer:SetWantsUpdates( false );
		if frmBI then
			backpackCount = 0;
			if SelCN == PN then
				SavePlayerBags();
				CountItems();
			end
		end
	end

	AddCallback(tbackpack, "ItemRemoved", function(sender, args) BIItemRemovedTimer:SetWantsUpdates( true ); end); --Workaround

	CountItems();
end

function CountItems()
	backpackCount = 0;
	if SelCN == Player:GetName() then backpackCount = tbackpack:GetSize();
	else for k, v in pairs(PlayerBags[SelCN]) do backpackCount = backpackCount + 1; end end
	SetBagsPack(SelCN);
end

function SetBagsPack(n)
	wBI.ListBox:ClearItems();
	itemCtl = {};
	titem = nil;
	
	for i = 1, backpackCount do
		-- Item control
		itemCtl[i] = Turbine.UI.Control();
		itemCtl[i]:SetSize( wBI.ListBox:GetWidth()-12, 34 );
		--if string.len(i / 2) <= 2 then itemCtl[i]:SetBackColor( Color["grey"] ); end --debug purpose

		if n == Player:GetName() then
			titem = tbackpack:GetItem(i);

			-- Item Background/Underlay/Shadow/Image
			local itemBG = Turbine.UI.Lotro.ItemControl( titem );
			itemBG:SetParent( itemCtl[i] );
			itemBG:SetSize( 34, 34 );
			itemBG:SetPosition( -2, -2 );
		else
			titem = PlayerBags[n][tostring(i)];

			-- Item Background
			local itemBG = Turbine.UI.Control();
			itemBG:SetParent( itemCtl[i] );
			itemBG:SetSize( 32, 32 );
			itemBG:SetPosition( 1, 1 );
			itemBG:SetBackground(tonumber(PlayerBags[n][tostring(i)].B));
			itemBG:SetBlendMode( Turbine.UI.BlendMode.Overlay );
			
			-- Item Underlay
			local itemU = Turbine.UI.Control();
			itemU:SetParent( itemCtl[i] );
			itemU:SetSize( 32, 32 );
			itemU:SetPosition( 1, 1 );
			if PlayerBags[n][tostring(i)].U ~= "0" then itemU:SetBackground(tonumber(PlayerBags[n][tostring(i)].U)); end
			itemU:SetBlendMode( Turbine.UI.BlendMode.Overlay );
			
			-- Item Shadow
			local itemS = Turbine.UI.Control();
			itemS:SetParent( itemCtl[i] );
			itemS:SetSize( 32, 32 );
			itemS:SetPosition( 1, 1 );
			if PlayerBags[n][tostring(i)].S ~= "0" then itemS:SetBackground(tonumber(PlayerBags[n][tostring(i)].S)); end
			itemS:SetBlendMode( Turbine.UI.BlendMode.Overlay );
			
			-- Item Image
			local item = Turbine.UI.Control();
			item:SetParent( itemCtl[i] );
			item:SetSize( 32, 32 );
			item:SetPosition( 1, 1 );
			item:SetBackground(tonumber(PlayerBags[n][tostring(i)].I));
			item:SetBlendMode( Turbine.UI.BlendMode.Overlay );

			-- Item Quantity
			local itemQTE = Turbine.UI.Label();
			itemQTE:SetParent( itemCtl[i] );
			itemQTE:SetSize( 32, 15 );
			itemQTE:SetPosition( -6, 14 );
			itemQTE:SetFont( Turbine.UI.Lotro.Font.Verdana12 );
			itemQTE:SetFontStyle( Turbine.UI.FontStyle.Outline );
			itemQTE:SetOutlineColor( Color["black"] );
			itemQTE:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
			itemQTE:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );
			itemQTE:SetForeColor( Color["nicegold"] );
			itemQTE:SetText(tonumber(PlayerBags[n][tostring(i)].N));
		end

		-- Item name
		local itemLbl = Turbine.UI.Label();
		itemLbl:SetParent( itemCtl[i] );
		itemLbl:SetSize( itemCtl[i]:GetWidth() - 35, 34 );
		itemLbl:SetPosition( 35, 1 );
		itemLbl:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
		itemLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		itemLbl:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );
		itemLbl:SetForeColor( Color["white"] );

		if titem ~= nil then
			if n == Player:GetName() then itemLbl:SetText( titem:GetName() );
			else itemLbl:SetText( PlayerBags[n][tostring(i)].T ); end
			wBI.ListBox:AddItem( itemCtl[i] );
		end
	end

	-- Set window title
	--wBI:SetText( L["MBI"] .. " - " .. L["VTFree"] .. ( backpackSize - backpackCount ) .. L["VTUsed"] .. backpackCount .. L["VTMax"] .. backpackSize );
end