-- DayNightWindow.lua
-- written by Habna


function frmDayNightWindow()
	local prevTS = _G.TS;
	local bHelp = false;
	
	frmDN = true;

	wDayNight = Turbine.UI.Lotro.Window()
	--wDayNight = Turbine.UI.Lotro.GoldWindow()
	
	-- **v Set backcolor, position, size and text of the window v**
	wDayNight:SetPosition( DNWLeft, DNWTop );
	wDayNight:SetText( L["MDayNight"] );
	wDayNight:SetWantsKeyEvents( true );
	wDayNight:SetVisible( true );
	--wDayNight:SetZOrder( 2 );
	wDayNight:Activate();

	if TBLocale == "fr" then wDayNight:SetWidth( 335 );
	else wDayNight:SetSize( 290 ); end

	wDayNight.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			wDayNight:Close();
		elseif ( args.Action == 268435635 ) or ( args.Action == 268435579 ) then -- Hide if F12 key is press or reposition UI
			wDayNight:SetVisible( not wDayNight:IsVisible() );
		end
	end

	wDayNight.MouseUp = function( sender, args )
		settings.DayNight.L = string.format("%.0f", wDayNight:GetLeft());
		settings.DayNight.T = string.format("%.0f", wDayNight:GetTop());
		DNWLeft, DNWTop = wDayNight:GetPosition();
		SaveSettings( false );
	end

	wDayNight.Closing = function( sender, args ) -- Function for the Upper right X icon
		wDayNight:SetWantsKeyEvents( false );

		if tonumber(_G.TS) == 0 then _G.TS = tonumber(prevTS); end
		settings.DayNight.S = string.format("%.0f",_G.TS);
		SaveSettings( false );
		UpdateDayNight();

		wDayNight = nil;
		frmDN = nil;
	end
	-- **^
	
	-- **v Show/Hide Next time - Check box v**
	local NextTimeCB = Turbine.UI.Lotro.CheckBox();
	NextTimeCB:SetParent( wDayNight );
	NextTimeCB:SetPosition( 35, 40 );
	NextTimeCB:SetText( L["NextT"] );
	NextTimeCB:SetSize( NextTimeCB:GetTextLength() * 8.5, 20 );
	NextTimeCB:SetChecked( _G.DNNextT );
	NextTimeCB:SetForeColor( Color["rustedgold"] );

	NextTimeCB.CheckedChanged = function( sender, args )
		_G.DNNextT = NextTimeCB:IsChecked();
		settings.DayNight.N = _G.DNNextT;
		SaveSettings( false );
		UpdateDayNight();
	end
	-- **^
	-- **v Timer seed - Label v**
	TAjustlbl = Turbine.UI.Label();
	TAjustlbl:SetParent( wDayNight );
	TAjustlbl:SetPosition( NextTimeCB:GetLeft(), NextTimeCB:GetTop() + 30 );
	TAjustlbl:SetText( L["TAjustL"] );
	TAjustlbl:SetSize( TAjustlbl:GetTextLength() * 8.5, 20 );
	TAjustlbl:SetForeColor( Color["rustedgold"] );
	-- **^
	-- **v Timer seed - Text box v**
	local TAjustTB = Turbine.UI.Lotro.TextBox();
	TAjustTB:SetParent( wDayNight );
	TAjustTB:SetPosition( TAjustlbl:GetLeft() + TAjustlbl:GetWidth(), TAjustlbl:GetTop() - 5 );
	TAjustTB:SetText( _G.TS );
	TAjustTB:SetMultiline( false );
	TAjustTB:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 );
	TAjustTB:SetSize( 75, 20 );
	TAjustTB:SetForeColor( Color["white"] );

	TAjustTB.FocusGained = function( sender, args )
		TAjustTB:SetWantsUpdates( true );
	end

	TAjustTB.FocusLost = function( sender, args )
		TAjustTB:SetWantsUpdates( false );
	end

	TAjustTB.Update = function( sender, args )
		local parsed_text = TAjustTB:GetText();

		if tonumber(parsed_text) == nil or string.find(parsed_text,"%.") ~= nil or parsed_text == "-0" or parsed_text == "+0" or parsed_text == "00" then
			TAjustTB:SetText( string.sub( parsed_text, 1, string.len(parsed_text)-1 ) );
			return
		elseif string.len(parsed_text) == 2 and string.sub(parsed_text,1,1) == "0" then
			TAjustTB:SetText( string.sub( parsed_text, 2 ) );
			return
		end

		_G.TS = parsed_text;
		settings.DayNight.S = string.format("%.0f",_G.TS);
		SaveSettings( false );
		UpdateDayNight();
	end
	-- **^
	-- **v ? - Button v**
	local Help = Turbine.UI.Lotro.Button();
	Help:SetParent( wDayNight );
	Help:SetPosition( TAjustTB:GetLeft()+TAjustTB:GetWidth() + 10, TAjustTB:GetTop() );
	Help:SetText( "?" );
	Help:SetSize( 10, 20 );
	Help:SetForeColor( Color["rustedgold"] );

	Help.Click = function( sender, args )
		bHelp = not bHelp;
		ShowHelpSection(bHelp);
	end
	-- **^
	-- **v ? - TextBox v**
	HelpTB = Turbine.UI.Label();
	HelpTB:SetParent( wDayNight );
	
	HelpTB:SetPosition( TAjustlbl:GetLeft(), TAjustlbl:GetTop()+TAjustlbl:GetHeight()+10 );
	HelpTB:SetForeColor( Color["rustedgold"] );
	HelpTB:SetVisible( bHelp );
	HelpTB:SetSize( wDayNight:GetWidth()-60, 250 );
	HelpTB:SetText( "Try using does value if time is not sync:\n\n* Arkenstone: ... 1295018461\n* Brandywine: ... 1295011363\n* Crickhollow: .. 1295013525\n* Dwarrowdelf: .. 1295019947\n* Elendilmir: ... 1295016509\n* Firefoot: ..... 1295018014\n* Gladden: ...... 1295020785\n* Imladris: ..... 1295032537\n* Landroval: .... 1295028066\n* Meneldor: ..... 1295035773\n* Nimrodel: ..... 1295030005\n* Riddermark: ... 1295038249\n* Silverlode: ... 1295039369\n* Vilya: ........ 1295040045\n* Windfola: ..... 1295037667" );
	-- **^
	
	ShowHelpSection(bHelp);
end

function ShowHelpSection(bHelp)
	if bHelp then
		wDayNight:SetHeight( wDayNight:GetHeight()+235 );
	else
		wDayNight:SetHeight( 105 );
	end
	HelpTB:SetVisible( bHelp );
end