-- SharedStorageWindow.lua
-- written by Habna


function frmSharedStorage()
	frmSS = true;
	tsspack = sspack;
	wSharedStorage = Turbine.UI.Lotro.Window()

	-- **v Set some window stuff v**
	wSharedStorage:SetText( L["MStorage"] );
	wSharedStorage:SetPosition( SSWLeft, SSWTop );
	wSharedStorage:SetSize( 390, 445 );
	wSharedStorage:SetWantsKeyEvents( true );
	wSharedStorage:SetVisible( true );
	--wSharedStorage:SetZOrder( 2 );
	--wSharedStorage:Activate();

	wSharedStorage.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			wSharedStorage:Close();
		elseif ( args.Action == 268435635 ) or ( args.Action == 268435579 ) then -- Hide if F12 key is press or reposition UI
			wSharedStorage:SetVisible( not wSharedStorage:IsVisible() );
		end
	end

	wSharedStorage.MouseUp = function( sender, args )
		settings.SharedStorage.L = string.format("%.0f", wSharedStorage:GetLeft());
		settings.SharedStorage.T = string.format("%.0f", wSharedStorage:GetTop());
		SSWLeft, SSWTop = wSharedStorage:GetPosition();
		SaveSettings( false );
	end

	wSharedStorage.Closing = function( sender, args ) -- Function for the Upper right X icon
		wSharedStorage:SetWantsKeyEvents( false );
		RemoveCallback( tsspack, "CountChanged" );
		wSharedStorage = nil;
		frmSS = nil;
	end
	-- **^
	-- **v Set the itemlistbox border v**
	wSharedStorage.ListBoxBorder = Turbine.UI.Control();
	wSharedStorage.ListBoxBorder:SetParent( wSharedStorage );
	wSharedStorage.ListBoxBorder:SetPosition( 15, 34 );
	wSharedStorage.ListBoxBorder:SetSize( wSharedStorage:GetWidth()-30, wSharedStorage:GetHeight()-53 );
	wSharedStorage.ListBoxBorder:SetBackColor( Color["grey"] );
	wSharedStorage.ListBoxBorder:SetVisible( true );
	-- **^
	-- **v Set the itemlistbox v**
	wSharedStorage.ListBox = Turbine.UI.ListBox();
	wSharedStorage.ListBox:SetParent( wSharedStorage );
	wSharedStorage.ListBox:SetPosition( wSharedStorage.ListBoxBorder:GetLeft() + 2, wSharedStorage.ListBoxBorder:GetTop() + 2 );
	wSharedStorage.ListBox:SetSize( wSharedStorage.ListBoxBorder:GetWidth() - 4, wSharedStorage.ListBoxBorder:GetHeight() - 4 );
	wSharedStorage.ListBox:SetMaxItemsPerLine( 1 );
	wSharedStorage.ListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	wSharedStorage.ListBox:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
	-- **^
	-- **v Set the scrollbar v**
	wSharedStorage.ListBoxScrollBar = Turbine.UI.Lotro.ScrollBar();
	--wSharedStorage.ListBoxScrollBar:SetParent( wSharedStorage );
	wSharedStorage.ListBoxScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
	wSharedStorage.ListBox:SetVerticalScrollBar( wSharedStorage.ListBoxScrollBar );
	wSharedStorage.ListBoxScrollBar:SetPosition( wSharedStorage:GetWidth()-28, wSharedStorage.ListBox:GetTop() + 2 );
	wSharedStorage.ListBoxScrollBar:SetSize( 10, wSharedStorage.ListBox:GetHeight() - 2 );
	-- **^
	
	sspackCount = 0;
	if PlayerSharedStorage ~= nil then for k, v in pairs(PlayerSharedStorage) do sspackCount = sspackCount + 1; end end

	if sspackCount == 0 then --Shared storage is empty
		wSharedStorage.ListBoxBorder:SetVisible( false );
		wSharedStorage.ListBox:SetVisible( false );
		
		local lblmgs = Turbine.UI.Label();
		lblmgs:SetParent( wSharedStorage );
		lblmgs:SetText( L["SSnd"] );
		lblmgs:SetPosition( 17, 40 );
		lblmgs:SetSize( wSharedStorage:GetWidth()-32, 39 );
		lblmgs:SetForeColor( Color["green"] );
		lblmgs:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
		
		wSharedStorage:SetHeight( lblmgs:GetHeight()+65 );
	else
		wSharedStorage.ListBoxScrollBar:SetParent( wSharedStorage );
		--sspackSize = tonumber(PlayerSharedStorage["1"].Z);
		--sspackCount = tsspack:GetCount();
		SetSharedStoragePack();
	end

	AddCallback(tsspack, "CountChanged", function(sender, args) if frmSS then sspackCount = tsspack:GetCount(); SetSharedStoragePack(); end end);
end

function SetSharedStoragePack()
	wSharedStorage.ListBox:ClearItems();
	itemCtl = {};

	for i = 1, sspackCount do
		-- Item control
		itemCtl[i] = Turbine.UI.Control();
		itemCtl[i]:SetSize( wSharedStorage.ListBox:GetWidth()-12, 35 );
		
		-- Item Background/Underlay/Shadow/Image
		local itemBG = Turbine.UI.Control();
		itemBG:SetParent( itemCtl[i] );
		itemBG:SetSize( 32, 32 );
		itemBG:SetPosition( 3, 3 );
		itemBG:SetBackground(tonumber(PlayerSharedStorage[tostring(i)].B));
		itemBG:SetBlendMode( Turbine.UI.BlendMode.Overlay );
		
		local itemU = Turbine.UI.Control();
		itemU:SetParent( itemCtl[i] );
		itemU:SetSize( 32, 32 );
		itemU:SetPosition( 3, 3 );
		if PlayerSharedStorage[tostring(i)].U ~= "0" then itemU:SetBackground(tonumber(PlayerSharedStorage[tostring(i)].U)); end
		itemU:SetBlendMode( Turbine.UI.BlendMode.Overlay );

		local itemS = Turbine.UI.Control();
		itemS:SetParent( itemCtl[i] );
		itemS:SetSize( 32, 32 );
		itemS:SetPosition( 3, 3 );
		if PlayerSharedStorage[tostring(i)].S ~= "0" then itemS:SetBackground(tonumber(PlayerSharedStorage[tostring(i)].S)); end
		itemS:SetBlendMode( Turbine.UI.BlendMode.Overlay );

		local item = Turbine.UI.Control();
		item:SetParent( itemCtl[i] );
		item:SetSize( 32, 32 );
		item:SetPosition( 3, 3 );
		item:SetBackground(tonumber(PlayerSharedStorage[tostring(i)].I));
		item:SetBlendMode( Turbine.UI.BlendMode.Overlay );

		-- Item Quantity
		local itemQTE = Turbine.UI.Label();
		itemQTE:SetParent( itemCtl[i] );
		itemQTE:SetSize( 32, 15 );
		itemQTE:SetPosition( -4, 16 );
		itemQTE:SetFont( Turbine.UI.Lotro.Font.Verdana12 );
		itemQTE:SetFontStyle( Turbine.UI.FontStyle.Outline );
		itemQTE:SetOutlineColor( Color["black"] );
		itemQTE:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
		itemQTE:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );
		itemQTE:SetForeColor( Color["nicegold"] );
		itemQTE:SetText(tonumber(PlayerSharedStorage[tostring(i)].N));

		-- Item name
		local itemLbl = Turbine.UI.Label();
		itemLbl:SetParent( itemCtl[i] );
		itemLbl:SetSize( itemCtl[i]:GetWidth() - 35, 35 );
		itemLbl:SetPosition( 37, 2 );
		itemLbl:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
		itemLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		itemLbl:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );
		itemLbl:SetForeColor( Color["white"] );
		itemLbl:SetText( PlayerSharedStorage[tostring(i)].T );

		wSharedStorage.ListBox:AddItem( itemCtl[i] );
	end

	-- Set window title
	--wSharedStorage:SetText( L["MStorage"] .. " - " .. L["VTFree"] .. ( sspackSize - sspackcount ) .. L["VTUsed"] .. sspackcount .. L["VTMax"] .. sspackSize );
end