-- TrackItemsWindow.lua
-- Written by Habna


local player = Turbine.Gameplay.LocalPlayer.GetInstance();
local backpack = player:GetBackpack();
local size = backpack:GetSize();

function frmTrackItemsWindow()
	frmTI = true;
	wTrackItems = Turbine.UI.Lotro.Window();
	--wTrackItems = Turbine.UI.Lotro.GoldWindow();
	
	wTrackItems:SetSize( 390, 432 );
    wTrackItems:SetPosition( BIWLeft, BIWTop );
	wTrackItems:SetText( L["BIIL"] );
	wTrackItems:SetVisible( true );
	wTrackItems:SetWantsKeyEvents( true );
	--wTrackItems:SetZOrder( 2 );
	wTrackItems:Activate();

	wTrackItems.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			wTrackItems:Close();
		elseif ( args.Action == 268435635 ) or ( args.Action == 268435579 ) then -- Hide if F12 key is press or reposition UI
			wTrackItems:SetVisible( not wTrackItems:IsVisible() );
		end
	end

	wTrackItems.MouseUp = function( sender, args )
		settings.BagInfos.L = string.format("%.0f", wTrackItems:GetLeft());
		settings.BagInfos.T = string.format("%.0f", wTrackItems:GetTop());
		BIWLeft, BIWTop = wTrackItems:GetPosition();
		SaveSettings( false );
	end

	wTrackItems.Closing = function( sender, args )
		wTrackItems:SetWantsKeyEvents( false );
		wTrackItems = nil;
		frmTI = nil;
	end
	
	local lblBackPack = Turbine.UI.Label();
	lblBackPack:SetParent( wTrackItems );
	lblBackPack:SetText( L["BIT"] );
	lblBackPack:SetPosition( 0, 35);
	lblBackPack:SetSize( wTrackItems:GetWidth() , 15 );
	lblBackPack:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	lblBackPack:SetForeColor( Color["green"] );

	ListBoxBorder = Turbine.UI.Control();
	ListBoxBorder:SetParent( wTrackItems );
	ListBoxBorder:SetPosition( 15, lblBackPack:GetHeight() + 40 );
	ListBoxBorder:SetSize( wTrackItems:GetWidth()-30, 354 );
	ListBoxBorder:SetBackColor( Color["grey"] );
	ListBoxBorder:SetVisible( true );

	TIListBox = Turbine.UI.ListBox();
	TIListBox:SetParent( wTrackItems );
	TIListBox:SetPosition( ListBoxBorder:GetLeft() + 2, ListBoxBorder:GetTop() + 2 );
	TIListBox:SetSize( ListBoxBorder:GetWidth() - 4, ListBoxBorder:GetHeight() - 4 );
	TIListBox:SetMaxItemsPerLine( 1 );
	TIListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	TIListBox:SetBackColor( Color["black"] );

	local ScrollBar = Turbine.UI.Lotro.ScrollBar();
	ScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
	ScrollBar:SetParent( wTrackItems );
	ScrollBar:SetPosition( wTrackItems:GetWidth() -28, TIListBox:GetTop() );
	ScrollBar:SetHeight( ListBoxBorder:GetHeight() );
	ScrollBar:SetSize( 10, TIListBox:GetHeight() - 2 );
	TIListBox:SetVerticalScrollBar( ScrollBar );

	RefreshBackPack();
end

function RefreshBackPack()
	local itemsCtl = {};
	local itemsLbl = {};
	TIListBox:ClearItems();
	bFound = false;
	TIPosY = 0;

	for i = 1, size do
		itemsCtl[i] = backpack:GetItem( i );

		if itemsCtl[i] ~= nil then
			local iteminfo = itemsCtl[i]:GetItemInfo();
						
			if iteminfo:GetMaxStackSize() > 1 then -- Only show stackable item
				bFound = true;

				-- Container for all infos
				itemsCtl[i] = Turbine.UI.Lotro.ItemControl( backpack:GetItem( i ) );
				itemsCtl[i]:SetSize( TIListBox:GetWidth(), 35 );

				-- Item name
				itemsLbl[i] = Turbine.UI.Label();
				itemsLbl[i]:SetParent( itemsCtl[i] );
				itemsLbl[i]:SetSize( TIListBox:GetWidth() - 48, 33 );
				itemsLbl[i]:SetPosition( 36, 3 );
				itemsLbl[i]:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
				itemsLbl[i]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
				itemsLbl[i]:SetBackColorBlendMode( 5 );
				itemsLbl[i]:SetForeColor( Color["white"] );
				itemsLbl[i]:SetText( iteminfo:GetName() );
				itemsLbl[i].Sel = false;

				itemsLbl[i].MouseClick = function( sender, args )
					if ( args.Button == Turbine.UI.MouseButton.Left ) then
						if not itemsLbl[i].Sel then
							itemsLbl[i].Sel = true;
							itemsLbl[i]:SetForeColor( Color["green"] );

							local tITL = {};
							tITL[itemsLbl[i]:GetText()] = {};
							tITL[itemsLbl[i]:GetText()].Q = tostring(iteminfo:GetQualityImageID());
							tITL[itemsLbl[i]:GetText()].B = tostring(iteminfo:GetBackgroundImageID());
							tITL[itemsLbl[i]:GetText()].U = tostring(iteminfo:GetUnderlayImageID());
							tITL[itemsLbl[i]:GetText()].S = tostring(iteminfo:GetShadowImageID());
							tITL[itemsLbl[i]:GetText()].I = tostring(iteminfo:GetIconImageID());
							table.insert( ITL, tITL );
							
							SavePlayerItemTrackingList(ITL);

							--Check all listbox for identical item name
							for ii = 1, size do
								if itemsCtl[ii] ~= "zEmpty" then
									if ii ~= i then
										if itemsLbl[i]:GetText() == itemsLbl[ii]:GetText() then itemsLbl[ii]:SetForeColor( Color["green"] ); itemsLbl[ii]:SetBackColor( Color["darkgrey"] ); itemsLbl[ii].Sel = true; end
									end
								end
							end
						else
							itemsLbl[i].Sel = false;
							itemsLbl[i]:SetForeColor( Color["white"] );

							local iFoundAt = 0;
							for ii = 1, #ITL do
								for k, v in pairs(ITL[ii]) do
									if k == itemsLbl[i]:GetText() then iFoundAt = ii; break end
								end
							end
						
							table.remove( ITL, iFoundAt );
							SavePlayerItemTrackingList(ITL)

							--Check all listbox for identical item name
							for ii = 1, size do
								if itemsCtl[ii] ~= "zEmpty" then
									if ii ~= i then
										if itemsLbl[i]:GetText() == itemsLbl[ii]:GetText() then itemsLbl[ii]:SetForeColor( Color["white"] ); itemsLbl[ii]:SetBackColor( Color["black"] ); itemsLbl[ii].Sel = false; end
									end
								end
							end
						end
					end
				end

				itemsLbl[i].MouseHover = function(sender, args)
					itemsLbl[i]:SetBackColor( Color["lightgrey"] );
				end

				itemsLbl[i].MouseLeave = function(sender, args)
					if itemsLbl[i].Sel then itemsLbl[i]:SetBackColor( Color["darkgrey"] ); else itemsLbl[i]:SetBackColor( Color["black"] ); end
				end

				TIListBox:AddItem( itemsCtl[i] );
				if TIListBox:GetItemCount() < 11 then TIPosY = TIPosY + 35; end
				TIListBox:SetHeight( TIPosY );
				ListBoxBorder:SetHeight( TIPosY+4 );
			else
				itemsCtl[i] = "zEmpty";
			end
		else
			itemsCtl[i] = "zEmpty";
		end
	end

	for i = 1, #ITL do
		for k, v in pairs(ITL[i]) do
			for ii = 1, size do
				if itemsCtl[ii] ~= "zEmpty" then --List box skip empty slot in bag but increment continue normally
					if k == itemsLbl[ii]:GetText() then itemsLbl[ii]:SetForeColor( Color["green"] ); itemsLbl[ii]:SetBackColor( Color["darkgrey"] ); itemsLbl[ii].Sel = true; end
				end
			end
		end
	end

	-- No stackable item was found in bag, show message
	if not bFound then
		TIPosY = TIPosY + 35;
		TIListBox:SetHeight( TIPosY );
		ListBoxBorder:SetHeight( TIPosY+4 );
		
		--**v Message v**
		local MsgLbl = Turbine.UI.Label();
		MsgLbl:SetPosition( 0, 0 );
		MsgLbl:SetText( L["BIMsg"] );
		MsgLbl:SetSize( TIListBox:GetWidth(), TIListBox:GetHeight() );
		MsgLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
		MsgLbl:SetForeColor( Color["red"] );
		--MsgLbl:SetBackColor( Color["white"] ); -- Debug purpose
		--**^

		TIListBox:AddItem( MsgLbl );
	end
end